#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#include "ImageWrapper.h"
#include "Image.h"
#include "HDRPreset.h"

@interface ImageUtils : NSObject

+ (nullable UIImage *)uiImageFromImage:(nonnull const photomatix::Image *)image;
+ (nullable UIImage *)uiImageFromImagePtr:(std::shared_ptr<photomatix::Image>)imagePtr;
//+ (id _Nullable)wrapException:(NS_NOESCAPE id _Nonnull (^)(void))block error:(NSError * _Nullable * _Nullable)error;
+ (nullable ImagePtrWrapper*) addImageToEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine fromFile:(nonnull NSString*)file error:(NSError * _Nullable * _Nullable)error;
+ (nullable ImagePtrWrapper*) addImageToEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine fromFile:(nonnull NSString*)file createFakeExposures:(bool)createFakeExposures error:(NSError * _Nullable * _Nullable)error;
+ (nullable ImageWrapper*) processWithEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine preset:(photomatix::HDRPreset)preset error:(NSError * _Nullable * _Nullable)error;
+ (nullable ImageWrapper*) processWithEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine preset:(photomatix::HDRPreset)preset isPanorama:(bool)isPanorama error:(NSError * _Nullable * _Nullable)error;

@end

