#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#include "PMImageWrapper.h"
#include "Image.h"
#include "HDRPreset.h"

@interface PMImageUtils : NSObject

+ (nullable UIImage *)uiImageFromImage:(nonnull const photomatix::Image *)image;
+ (nullable UIImage *)uiImageFromImagePtr:(std::shared_ptr<photomatix::Image>)imagePtr;
//+ (id _Nullable)wrapException:(NS_NOESCAPE id _Nonnull (^)(void))block error:(NSError * _Nullable * _Nullable)error;
+ (nullable PMImagePtrWrapper*) addImageToEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine fromFile:(nonnull NSString*)file error:(NSError * _Nullable * _Nullable)error;
+ (nullable PMImagePtrWrapper*) addImageToEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine fromFile:(nonnull NSString*)file createFakeExposures:(bool)createFakeExposures error:(NSError * _Nullable * _Nullable)error;
+ (nullable PMImagePtrWrapper*) addImageToEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine fromUIImage : (nonnull UIImage*)image error : (NSError * _Nullable * _Nullable)error;
+ (nullable PMImageWrapper*) processWithEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine preset:(photomatix::HDRPreset)preset error:(NSError * _Nullable * _Nullable)error;
+ (nullable PMImageWrapper*) processWithEngine:(std::shared_ptr<photomatix::PhotomatixEngine>)engine preset:(photomatix::HDRPreset)preset isPanorama:(bool)isPanorama error:(NSError * _Nullable * _Nullable)error;

@end

