#import <Foundation/Foundation.h>
#include <memory>
#include "PhotomatixEngine.h"

NS_ASSUME_NONNULL_BEGIN

@interface PMImageWrapper : NSObject

// For Swift compatibility
+ (nullable PMImageWrapper*)createWithImage:(std::shared_ptr<photomatix::Image>)image;

- (instancetype)initWithImage:(std::shared_ptr<photomatix::Image>)image;

// Access Underlying C++ Image
@property(nonatomic, readonly) std::shared_ptr<photomatix::Image> image;

@end

@interface PMImagePtrWrapper : NSObject

// For Swift compatibility
+ (nullable PMImagePtrWrapper*)createWithImagePtr:(photomatix::Image*)imagePtr;

- (instancetype)initWithImagePtr:(photomatix::Image*)imagePtr;

// Access Underlying C++ Image
@property(nonatomic, readonly) photomatix::Image* image;

@end

NS_ASSUME_NONNULL_END
